const { apiRequest } = require('../../utils/API.js')
let prevpage = '/pages/index/index'

Page({

  /**
   * 页面的初始数据
   */
  data: {
    canIUse: wx.canIUse('button.open-type.getUserInfo')
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    prevpage = options.prevpage ? options.prevpage : '/pages/index/index'
    if (options.prevpage && options.querys) {
      let querys = ''
      options.querys.split(',').map(item => {
        querys += item.split('~')[0] + '=' + item.split('~')[1] + '&'
      })
      querys = '?' + querys.slice(0, querys.length - 1)
      prevpage = prevpage + querys
    }
  },
  getUserInfoEvent: function (e) {
    let that = this
    if (e.detail.userInfo) {
      wx.showLoading({
        title: '登陆中',
        mask: true
      })
      wx.login({
        success: res => {
          let data = {
            encrypted_data: e.detail.encryptedData,
            iv: e.detail.iv,
            js_code: res.code
          }
          apiRequest('/auth/signin', data).then(result => {
            wx.setStorage({
              key: 'USER_INFO',
              data: result.data
            })
            if (prevpage == '/pages/index/index' || prevpage == '/pages/mine/mine') {
              wx.switchTab({
                url: prevpage,
                success: function() {
                  wx.hideLoading()
                }
              })
            } else {
              wx.redirectTo({
                url: prevpage,
                success: function () {
                  wx.hideLoading()
                }
              })
            }
          }).catch(err => {
            wx.hideLoading()
            wx.showToast({
              title: '登陆失败，请重试',
              icon: 'none'
            })
          })
        }
      })
    }
  }
})